import { Component, OnInit, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';

export interface DeleteMessageDialogData {
  title: string;
  message?: string;
}

export interface DeleteMessageDialogResult {
  choice: boolean;
}

@Component({
  selector: 'app-layout-messenger-delete-message',
  templateUrl: './delete-message.dialog.component.html',
  styleUrls: ['./delete-message.dialog.component.scss']
})
export class DeleteMessageDialogComponent implements OnInit {
  constructor(
    public dialogRef: MatDialogRef<
      DeleteMessageDialogData,
      DeleteMessageDialogResult
    >,
    @Inject(MAT_DIALOG_DATA) public data: DeleteMessageDialogData
  ) {}

  ngOnInit(): void {}

  onClickChoice(choice: boolean): void {
    this.dialogRef.close({
      choice
    });
  }
}
